<?

//========= Задаем параметры капчи(при желании можно вынести в отдельный файл - config)
// шрифт символов на капче( шрифт лучше положить в папку со скриптом)
$font = '../../theme/fonts/Roboto.ttf';
// Размер шрифта
$fontsize = 20;
// Размер капчи
$width = 120; // - длина
$height = 40; // - высота
// количество полосок на капче
$countLine = 3;
//==========

// Задаем заголовок для вывода картинки
header('Content-type: image/png');
// Создаем изображение
$img = imagecreatetruecolor($width, $height);
// фон для капчи
$background = imagecolorallocate($img, 255, 255, 255);
imagefill($img, 0, 0, $background);
// Переменная, для хранения значения капчи
$capchaText = '';

// придумываем пример для капчи
$a = mt_rand(1, 99);
$b = mt_rand(1, 99);
$capchaText = $a . '+' . $b . '=';
// Ответ на пример, запишем в сессию для проверки
$capchaResult = $a + $b;

// ========= Заполням изображение символами
for ($i = 0; $i < strlen($capchaText); $i++){
    // Из списка символов, берем случайный символ
    $litteral = $capchaText[$i];
    // Вычисляем положение одного символа
    $x = ($width - 20) / strlen($capchaText) * $i + 10;
    $y = $height - (($height - $fontsize) / 2);
    // Сгенерируем случайный цвет для символа
    $color = imagecolorallocate($img, rand(0, 155), rand(0, 155), rand(0, 155) );
    // Генерируем угол наклона символа
    $naklon = rand(-10, 10);
    // Рисуем один символ
    imagettftext($img, $fontsize, $naklon, $x, $y, $color, $font, $litteral);
}
// ==========

// ========== Добавим на капчу несколько рандомных полосок
for ($i = 0; $i < $countLine; $i++){
    // сгенерируем координаты для линии
    $part = $width/100; // длина картинки в процентах
    $x1 = mt_rand(0, round($part*30)); // x1 не больше чем до 30% картики
    $y1 = mt_rand(0, $height);
    $x2 = mt_rand(round($part*70), round($part*100)); // x2 не меньше чем от 70% картики
    $y2 = mt_rand(0, $height);
    // сгенерируем случайный цвет для линии
    $color = imagecolorallocate($img, rand(0, 155), rand(0, 155), rand(0, 155) );
    imageline ($img, $x1, $y1, $x2, $y2, $color );
}
// ==========

// ========== Шумы (noise)
//$white_noise_density=0; // no white noise
//$black_noise_density=0; // no black noise
$white_noise_density=1/6;
$black_noise_density=1/30;
$white = imagecolorallocate($img, 255, 255, 255);
$black = imagecolorallocate($img, 0, 0, 0);
  for($i=0;$i<(($height-30)*$x)*$white_noise_density;$i++){
    imagesetpixel($img, mt_rand(0, $x-1), mt_rand(10, $height-15), $white);
  }
  for($i=0;$i<(($height-30)*$x)*$black_noise_density;$i++){
    imagesetpixel($img, mt_rand(0, $x-1), mt_rand(10, $height-15), $black);
  }
// ==========

$img2 = imagecreatetruecolor($width, $height);

// случайные параметры (можно поэкспериментировать с коэффициентами):
// частоты
$rand1 = mt_rand(700000, 1000000) / 15000000;
$rand2 = mt_rand(700000, 1000000) / 15000000;
$rand3 = mt_rand(700000, 1000000) / 15000000;
$rand4 = mt_rand(700000, 1000000) / 15000000;
// фазы
$rand5 = mt_rand(0, 3141592) / 1000000;
$rand6 = mt_rand(0, 3141592) / 1000000;
$rand7 = mt_rand(0, 3141592) / 1000000;
$rand8 = mt_rand(0, 3141592) / 1000000;
// амплитуды
$rand9 = mt_rand(400, 600) / 100;
$rand10 = mt_rand(400, 600) / 100;
 
for($x = 0; $x < $width; $x++){
  for($y = 0; $y < $height; $y++){
    // координаты пикселя-первообраза.
    $sx = $x + ( sin($x * $rand1 + $rand5) + sin($y * $rand3 + $rand6) ) * $rand9;
    $sy = $y + ( sin($x * $rand2 + $rand7) + sin($y * $rand4 + $rand8) ) * $rand10;
 
    // первообраз за пределами изображения
    if($sx < 0 || $sy < 0 || $sx >= $width - 1 || $sy >= $height - 1){ 
      $color = 255;
      $color_x = 255;
      $color_y = 255;
      $color_xy = 255;
    }else{ // цвета основного пикселя и его 3-х соседей для лучшего антиалиасинга
      $color = (imagecolorat($img, $sx, $sy) >> 16) & 0xFF;
      $color_x = (imagecolorat($img, $sx + 1, $sy) >> 16) & 0xFF;
      $color_y = (imagecolorat($img, $sx, $sy + 1) >> 16) & 0xFF;
      $color_xy = (imagecolorat($img, $sx + 1, $sy + 1) >> 16) & 0xFF;
    }

    // сглаживаем только точки, цвета соседей которых отличается
    if($color == $color_x && $color == $color_y && $color == $color_xy){
      $newcolor=$color;
    }else{
      $frsx = $sx - floor($sx); //отклонение координат первообраза от целого
      $frsy = $sy - floor($sy);
      $frsx1 = 1 - $frsx;
      $frsy1 = 1 - $frsy;

      // вычисление цвета нового пикселя как пропорции от цвета основного пикселя и его соседей
      $newcolor = floor( $color    * $frsx1 * $frsy1 +
                         $color_x  * $frsx  * $frsy1 +
                         $color_y  * $frsx1 * $frsy  +
                         $color_xy * $frsx  * $frsy );
    }
    imagesetpixel($img2, $x, $y, imagecolorallocate($img2, $newcolor, $newcolor, $newcolor));
  }
}

// Запускаем сессию, и записывем в нее значение капчи. Это понадобится для проверки с тем, что вводит юзер
session_start();
$_SESSION['ariphmetic_captcha'] = $capchaResult;
// вывод капчи на страницу
imagepng($img2);
// чистим память, которую мы заняли при создании картинки
imagedestroy($img2);

?>